#include<bits/stdc++.h>

using namespace std;
int N;
int O, A, B , AB;
string pacijent;
int kolicina[1000010];
int main(){

    cin >> N;
    cin >> O >> A >> B >> AB;
    for(int i = 1; i <= N; i++){
cin >> pacijent >> kolicina[1000010];
    }
 if (pacijent == "O"){
if(kolicina[1000010] >= O){
    cout << "nemoguce" << endl;
}
}
if (pacijent == "A"){
if(kolicina[1000010] >= A){
    cout << "nemoguce" << endl;
}
}
if (pacijent == "B"){
if(kolicina[1000010] >= B){
    cout << "nemoguce" << endl;
}
}

if (pacijent == "AB"){
if(kolicina[1000010] >= AB){
    cout << "nemoguce" << endl;
}
}

return 0;
}